<template>
  <div id="lc_question_editor_wrapper">
    <el-form-item :label="$t('QUESTION.TYPE')" id="question_type">
      <el-radio-group @change="onChangeBody" v-model="inputBody.questionType">
        <el-radio-button label="SHORT_ANSWER">{{ $t('QUESTION.SHORT_ANS') }}</el-radio-button>
        <el-radio-button label="MULTIPLE_CHOICE">{{ $t('QUESTION.MULTI_ANS') }}</el-radio-button>
        <el-radio-button label="DESCRIPTION">{{ $t('QUESTION.ESSAY') }}</el-radio-button>
        <el-radio-button label="SW">SW</el-radio-button>
        <el-radio-button label="SQL">SQL</el-radio-button>
        <el-radio-button label="MULTIMEDIA">{{ $t('QUESTION.MULTIMEDIA') }}</el-radio-button>
        <el-radio-button label="CONNECTION">{{ $t('QUESTION.CONNECTION') }}</el-radio-button>
      </el-radio-group>
    </el-form-item>
    <div v-if="inputBody.questionType !== null" ref="hello">
      <el-form-item :label="$t('QUESTION.QUESTION')" id="question">
        <el-input v-model="inputTail.question" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea" :autosize="{ minRows: 10, maxRows: 15 }"></el-input>
      </el-form-item>
      <el-form-item :label="$t('QUESTION.ADD_IMG_FILE')">
        <el-upload
          action="#"
          :auto-upload="false"
          :on-change="handleChange"
          ref="questionUpload">
          <el-button slot="trigger" :title="$t('UPLOAD.SUB_IMG')" type="primary" icon="fas fa-file-image"></el-button>
          <span slot="tip" class="el-upload__tip"> {{ $t('UPLOAD.ONLY_IMG') }}</span>
        </el-upload>
      </el-form-item>

      <el-form-item
        :label="$t('QUESTION.QUESTION_FORMAT')">
        <el-select v-model="inputTail.questionMediaType">
          <el-option
            v-for="item in questionMediaOptions"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
        
        <div v-if="inputTail.questionMediaType === 'youtube'" style="display: inline-block; width: 100%; margin-top: 10px">
          <el-button style="width: 70px" :title="$t('UPLOAD.ADD_YT_URL')" icon="fas fa-video" plain></el-button>
          <div style="display: inline-block; width: 80%;">
            <el-input v-model="inputTail.questionYoutubeURL" :placeholder="$t('UPLOAD.ENTER_YT_ADDR')"></el-input>
          </div>
        </div>

        <div v-if="inputTail.questionMediaType === 'voice'" style="display: inline-block; width: 100%; margin-top: 10px">
          <div v-if="inputTail.recordingBtnNum !== 6"> <!-- 5까지는 객관식에서 사용할 수 있을 것 같아서 임의로 6번 부여함 -->
            <el-button type="primary" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="startRecording(6)"></el-button>
            <span style="margin-left: 10px" slot="tip" class="el-upload__tip">{{ $t('UPLOAD.PRESS_RECORDING') }}</span>
          </div>
          <div v-if="inputTail.recordingBtnNum === 6">
            <el-button type="danger" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="finishRecording(6)"></el-button>
            <span style="margin-left: 10px"  slot="tip" class="el-upload__tip">{{ $t('UPLOAD.PRESS_RECORDING') }}</span>
          </div>
          <audio controls :src="inputTail.questionBlobURL"></audio>
        </div>
      </el-form-item>

      <template v-if="inputBody.questionType === 'SHORT_ANSWER'">
        <el-form-item :label="$t('QUESTION.ANSWER')" id="textarea_short_answer">
          <!-- el-input v-model="inputTail.answer[0]" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input> -->
          <el-input
            v-for="(item, index) in inputTail.answer"
            :key="index"
            :placeholder="$t('QUESTION.ENTER_ANS')"
            v-model="inputTail.answer[index]"
            type="textarea"
          />
          <el-button type="primary" @click="onClick('ADD_ANSWER')">{{ $t('QUESTION.ADD') }}</el-button>
          <el-button v-if="inputTail.answer.length > 1" type="danger" @click="onClick('DELETE_ANSWER')">{{ $t('QUESTION.ELIMINATE') }}</el-button>
        </el-form-item>
      </template>
      <template v-if="inputBody.questionType === 'MULTIPLE_CHOICE'">
        <el-form-item v-if="inputTail.questionList !== undefined" :label="$t('QUESTION.CHOICE')">
          <el-checkbox-group v-model="inputTail.answer" style="width: 100%;">
            <template v-for="index in [0, 1, 2, 3, 4]">
              <el-row :key="index + 8798321324">
                <el-checkbox :key="index + 12365497" :label="index + 1" style="vertical-align:top">{{ index + 1 }}.</el-checkbox>
                <div :key="index + 987654" style="display: inline-block; width: 90%;">
                  <div v-if="inputTail.multiChoiceMediaType === 'none' || inputTail.multiChoiceMediaType === undefined" style="display: inline-block; width: 100%">
                    <el-input v-model="inputTail.questionList[index]" :placeholder="$t('QUESTION.ENTER_CON')"></el-input>
                  </div>
                  
                  <div v-if="inputTail.multiChoiceMediaType === 'youtube'" style="display: inline-block; width: 100%; margin-left: 50px">
                    <el-button style="width: 70px" :title="$t('UPLOAD.ADD_YT_URL')" icon="fas fa-video" plain></el-button>
                    <div style="display: inline-block; width: 80%;">
                      <el-input v-model="inputTail.questionList[index]" :placeholder="$t('UPLOAD.ENTER_YT_ADDR')"></el-input>
                    </div>                
                  </div>

                  <div v-if="inputTail.multiChoiceMediaType === 'image'" style="display: inline-block; width: 100%; margin-left: 50px">
                    <el-upload 
                      style="display: span"
                      action="#"
                      :auto-upload="false"
                      :on-exceed="handleExceed"
                      :limit="10"
                      :ref='getRefName(index)'>
                      <el-button :title="$t('UPLOAD.SUB_IMG')" type="primary" icon="fas fa-file-image"></el-button>
                      <span slot="tip" class="el-upload__tip"> {{ $t('UPLOAD.ONLY_ONE_IMG') }}</span>
                    </el-upload>
                  </div>

                  <div v-if="inputTail.multiChoiceMediaType === 'voice'" style="display: inline-block; width: 100%; margin-left: 50px">
                    <div v-if="inputTail.recordingBtnNum !== index">
                      <el-button type="primary" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="startRecording(index)"></el-button>
                      <span style="margin-left: 10px" slot="tip" class="el-upload__tip">{{ $t('UPLOAD.PRESS_RECORDING') }}</span>
                    </div>
                    <div v-if="inputTail.recordingBtnNum === index">
                      <el-button type="danger" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="finishRecording(index)"></el-button>
                      <span style="margin-left: 10px"  slot="tip" class="el-upload__tip">{{ $t('UPLOAD.PRESS_RECORDING') }}</span>
                    </div>
                    <audio controls :src="inputTail.blobURL[index]"></audio>
                  </div>
                </div>
              </el-row>
            </template>
          </el-checkbox-group>
          <span>{{ $t('QUESTION.MULTI_CHOI_MEDIA') }} : </span>
            <el-select @change="onChangeMultichoiceMediaType" v-model="inputTail.multiChoiceMediaType">
              <el-option
                v-for="item in mediaOptions"
                :key="item.value"
                :label="item.label"
                :value="item.value">
              </el-option>
            </el-select>
        </el-form-item>
      </template>

      <template v-if="inputBody.questionType === 'DESCRIPTION'">
        <el-form-item :label="$t('QUESTION.IDEAL')" id="textarea_short_answer">
          <el-input v-model="inputTail.answer[0]" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea" :autosize="{ minRows: 10, maxRows: 15 }"></el-input>
        </el-form-item>
        <el-form-item>
          <el-upload
            action="#"
            :auto-upload="false"
            ref="answerUpload">
            <el-button slot="trigger" type="primary">{{ $t('NOTE.ADD_FILE') }}</el-button>
          </el-upload>
        </el-form-item>
      </template>

      <template v-if="inputBody.questionType === 'SW'">
        <el-form-item :label="$t('QUESTION.LANG')">
          <el-select v-model="inputTail.language">
            <el-option
              v-for="language in languageList"
              :key="language.value"
              :label="language.label"
              :value="language.value">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.INPUT')">
          <el-input v-model="inputTail.inputDescription" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.OUTPUT')">
          <el-input v-model="inputTail.outputDescription" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.INPUT_SAMPLE')">
          <el-input v-model="inputTail.sampleInput" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.OUTPUT_SAMPLE')">
          <el-input v-model="inputTail.sampleOutput" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.CODE')">
          <el-input type="textarea" :autosize="{ minRows: 5 }" v-model="inputTail.code" :placeholder="$t('QUESTION.ENTER_CON')"></el-input>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.TEST_CASE')">
          <el-button
            type="primary"
            size="small"
            @click="showAddTestcaseDialog"
            style="float: right">
            {{ $t('QUESTION.ADD_TESTCASE') }}
          </el-button>
          <el-button
            size="small"
            @click="generateOutput"
            style="float: right; margin-right: 10px;">
            {{ $t('QUESTION.GENERATE_OUTPUT')}}
          </el-button>
          <el-table
            :key="testcaseKey"
            :data="inputTail.testCaseList"
            @selection-change="handleSelectionChange">
            <el-table-column
              type="selection"
              width="55"
              align="center">
            </el-table-column>
            <el-table-column
              type="index"
              label="#"
              width="50"
              align="center">
            </el-table-column>
            <el-table-column
              prop="input"
              :label="$t('QUESTION.IN')"
              :show-overflow-tooltip="true">
            </el-table-column>
            <el-table-column
              prop="output"
              :label="$t('QUESTION.OUT')"
              :show-overflow-tooltip="true">
            </el-table-column>
            <el-table-column
              prop="score_ratio"
              :label="$t('ITEM.WEIGHT')"
              width="100"
              align="center">
            </el-table-column>
            <el-table-column
              label="-"
              width="80"
              align="center">
              <template
                slot-scope="scope">
                <el-button
                  type="primary"
                  size="small"
                  @click="() => { showChangeTestcaseDialog(scope.$index) }">
                  {{ $t('QUESTION.EDIT') }}
                </el-button>
              </template>
            </el-table-column>
            <el-table-column
              label="-"
              width="80"
              align="center">
              <template
                slot-scope="scope">
                <el-button
                  type="danger"
                  size="small"
                  @click="() => { deleteTestcase(scope.$index) }">
                  {{ $t('QUESTION.DELETE') }}
                </el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-form-item>
        <!-- <el-form-item :label="$t('QUESTION.NEW_CASE')">
          <el-button @click="onClick('ADD_TEST_CASE')">{{ $t('QUESTION.ADD') }}</el-button>
        </el-form-item>
        <template v-if="inputTail.testCaseList !== undefined">
          <div v-for="(testCase, index) in inputTail.testCaseList" :key="index">
            <el-form-item :label="$t('QUESTION.ENTER_CASE')">
              <el-input v-model="testCase.input" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
            </el-form-item>
            <el-form-item :label="$t('QUESTION.OUT')">
              <el-input v-model="testCase.output" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
            </el-form-item>
            <el-form-item :label="$t('QUESTION.SCORE_RATIO')">
              <el-input-number v-model="testCase.score_ratio" :min='1' :placeholder="$t('QUESTION.ENTER_CON')"></el-input-number>
            </el-form-item>
            <div style="text-align: right;">
            <el-button type="danger" @click="onClick('DELETE_TEST_CASE', index)">{{ $t('QUESTION.TEST_CASE') }} {{ index }} {{ $t('QUESTION.DELETE') }}</el-button>
            <br /><br /><br />
            </div>
          </div>
        </template> -->
        <!-- <el-form-item :label="$t('QUESTION.MEM_LIMIT')">
          <el-input v-model="inputTail.memoryLimit" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.TIME_LIMIT')">
          <el-input v-model="inputTail.timeLimit" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
        </el-form-item> -->
        <el-form-item :label="$t('QUESTION.MEM_LIMIT')">
          <el-input-number v-model="inputTail.memoryLimit" :step="1" step-strictly :precision="0"></el-input-number> MB
        </el-form-item>
        <el-form-item :label="$t('QUESTION.TIME_LIMIT')">
          <el-input-number v-model="inputTail.timeLimit" :step="1" step-strictly :precision="0"></el-input-number> ms
        </el-form-item>
      </template>

      <div v-show="inputBody.questionType === 'SQL'">
        <el-form-item label="SQLite">
          <el-upload
            action="#"
            :auto-upload="false"
            :limit=1
            :on-exceed="handleExceed"
            ref="sqlUpload">
            <el-button>{{ $t('NOTE.ADD_FILE') }}</el-button>
          </el-upload>
        </el-form-item>
        <el-form-item :label="$t('QUESTION.ANSWER')">
          <el-input v-model="inputTail.answer[0]" :placeholder="$t('QUESTION.ENTER_CON')" type="textarea"></el-input>
        </el-form-item>
      </div>

      <el-form-item
        v-if="inputBody.questionType === 'MULTIMEDIA'"
        :label="$t('QUESTION.ANSWER_FORMAT')">
        <el-select v-model="inputTail.answerMediaType">
          <el-option
            v-for="item in mediaOptions"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
      </el-form-item>
      <div ref="cool">

      </div>
      <el-form-item v-if="inputTail.questionList !== undefined && inputBody.questionType === 'CONNECTION'" :label="$t('QUESTION.CHOICE')">
        <el-row style="margin: 0px; padding: 0px;">
          <el-col :span="inputTail.multiChoiceMediaType === 'image' || inputTail.multiChoiceMediaType === 'voice' ? 9 : 12" id="canvasColLeft">
            <div v-for="index in [0,1,2,3,4]" :key="index + 89794">
              <div v-if="inputTail.multiChoiceMediaType === 'none' || inputTail.multiChoiceMediaType === undefined">
                <span>{{ index + 1 }}.</span>
                <el-input v-model="inputTail.questionList[index]" :placeholder="$t('QUESTION.ENTER_CON')" style="width: 95%; float: right;"></el-input>
              </div>
              <div v-if="inputTail.multiChoiceMediaType === 'youtube'">
                <span>{{ index + 1 }}. </span>
                <el-button :title="$t('UPLOAD.ADD_YT_URL')" icon="fas fa-video" plain style="margin-left: 2px; box-sizing: border-box;"></el-button>
                <el-input v-model="inputTail.questionList[index]" :placeholder="$t('UPLOAD.ENTER_YT_ADDR')" style='width: calc(82% - 2px); float: right;'></el-input>
              </div>
              <div v-if="inputTail.multiChoiceMediaType === 'image'" :style="`${bogiSize[index] ? 'height: 100px;' : 'height: 40px;'}`">
                <el-row style="padding-left: 10px; margin: 0px;">
                  <span style="vertical-align: top;">{{ index + 1 }}. </span>
                  <div style="display: inline-block; margin-left: 5px;">
                    <el-upload
                      action="#"
                      :auto-upload="false"
                      :on-exceed="handleExceed"
                      :limit="1"
                      :ref='getRefName(index)'
                      :on-change="changeBogiSize">
                      <el-button :title="$t('UPLOAD.SUB_IMG')" type="primary" icon="fas fa-file-image"></el-button>
                      <span slot="tip" class="el-upload__tip">{{ $t('UPLOAD.ONLY_ONE_IMG') }}</span>
                    </el-upload>
                  </div>
                </el-row>
              </div>
              <div v-if="inputTail.multiChoiceMediaType === 'voice'" style="height: 100px;">
                <span style="vertical-align: top;">{{ index + 1 }}. </span>
                <div style="display: inline-block; margin-left: 5px;">
                  <div v-if="inputTail.recordingBtnNum !== index">
                    <el-button type="primary" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="startRecording(index)"></el-button>
                    <span style="margin-left: 10px" slot="tip" class="el-upload__tip">{{ $t('UPLOAD.PRESS_RECORDING') }}</span>
                  </div>
                  <div v-if="inputTail.recordingBtnNum === index">
                    <el-button type="danger" :title="$t('UPLOAD.VOICE_RECORDING')" icon="fa fa-microphone" @click="finishRecording(index)"></el-button>
                    <span style="margin-left: 10px"  slot="tip" class="el-upload__tip">{{ $t('UPLOAD.PRESS_RECORDING') }}</span>
                  </div>
                  <audio controls :src="inputTail.blobURL[index]"></audio>
                </div>
              </div>
            </div>
          </el-col>
          <el-col :span="inputTail.multiChoiceMediaType === 'image' || inputTail.multiChoiceMediaType === 'voice' ? 8 : 5" id="canvasCol">
            <canvas id="canvas"></canvas>
          </el-col>
          <el-col :span="7">
            <div v-for="index in [0,1,2,3,4]" :key="index + refreshCount" :style="`${inputTail.multiChoiceMediaType === 'voice' || bogiSize[index] ? 'height: 100px;' : 'height: 40px;'}`">
              <span>{{ String.fromCharCode(index + 65) }}.</span>
              <el-input v-model="inputTail.choice2[index]" :key="refreshCount" :placeholder="$t('QUESTION.ENTER_ANS')" :style="`width: 90%; margin-left: 2px; ${inputTail.multiChoiceMediaType === 'voice' || bogiSize[index] ? 'margin-top: 30px;' : ''}`"></el-input>
            </div>
          </el-col>
        </el-row>
        <span>{{ $t('QUESTION.MULTI_CHOI_MEDIA') }} : </span>
        <el-select @change="onChangeMultichoiceMediaType" v-model="inputTail.multiChoiceMediaType">
          <el-option
            v-for="item in mediaOptions"
            :key="item.value"
            :label="item.label"
            :value="item.value">
          </el-option>
        </el-select>
        <el-button @click="resetSelectEl" type="primary" style="width: 100px; padding-left: 10px; padding-right: 10px;">
          {{ $t('QUESTION.RESET_LINE') }}
        </el-button>
    </el-form-item>
      
    <el-form-item :label="$t('QUESTION.LEVEL')" id="difficulty">
      <el-select v-model.number="inputTail.difficulty">
        <el-option
          v-for="level in difficultyList"
          :key="level"
          :label="level"
          :value="level">
        </el-option>
      </el-select>
    </el-form-item>
    </div>
    <el-dialog
      :title="$t('QUESTION.ADD_TESTCASE')"
      :visible.sync="addTestcaseVisible"
      :close-on-click-modal="false"
      :close-on-press-escape="false"
      width="40%"
      center>
      <el-form
        :model="testcaseForm"
        label-position="top">
        <el-form-item
          :label="$t('QUESTION.TESTCASE_INPUT')">
          <el-input
            type="textarea"
            :autosize="{ minRows: 5}"
            :placeholder="$t('QUESTION.ENTER_CON')"
            v-model="testcaseForm.input">
          </el-input>
        </el-form-item>
        <el-form-item
          :label="$t('QUESTION.TESTCASE_OUTPUT')">
          <el-input
            type="textarea"
            :autosize="{ minRows: 5}"
            :rows="{ minRows: 5}"
            :placeholder="$t('QUESTION.ENTER_CON')"
            v-model="testcaseForm.output">
          </el-input>
        </el-form-item>
        <el-form-item
          :label="$t('ITEM.WEIGHT')">
          <el-input-number
            v-model="testcaseForm.score_ratio"
            :min="1"
            :max="10"
            :step="1"
            :precision="0"
            step-strictly>
          </el-input-number>
        </el-form-item>
      </el-form>
      <div
        style="height: 30px;">
        <el-button
          @click="cancelAddTestCase"
          style="float: right;">
          {{ $t('QUESTION.CANCEL')}}
        </el-button>
        <el-button
          type="primary"
          v-if="currentTestcaseIndex > -1"
          @click="changeTestCase"
          style="float: right; margin-right: 10px;">
          {{ $t('QUESTION.CHANGE_TESTCASE') }}
        </el-button>
        <el-button
          type="primary"
          v-else
          @click="addTestCase"
          style="float: right; margin-right: 10px;">
          {{ $t('QUESTION.ADD_TESTCASE') }}
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
// TODO : 메모리, 시간 정수형으로 validate!!!
import { mapState } from 'vuex';
import { getIdFromURL } from 'vue-youtube-embed';
import questionService from '../../services/questionService';

export default {
  name: 'LcQuestionEditor',
  data() {
    const vm = this;
    const initialInputBody = {
      questionType: null,
    };
    const initialInputTail = {
      assignedKeywordList: [],
      testCaseList: [],
      language: '',
      answer: [],
      difficulty: 3,
      questionFile: [],
      audioBlob: [],
      answerMediaType: 'none',
      multiChoiceMedia: [],
      multiChoiceMediaType: 'none',
      blobURL: [],
      question: '',
      questionMediaType: 'none',
      questionBlobURL: undefined,
      questionYoutubeURL: undefined,
      questionVoiceFile: undefined,
      choice2: [],
      recordingBtnNum: -1, // 녹음중인 버튼 번호 / -1 : 어떤 버튼도 녹음중이 아님, 0~ 해당 버튼이 녹음중 / 6 : 문제 형식에서 사용
      recorder: null,
      multipleSelection: [],
      code: '',
      memoryLimit: 128,
      timeLimit: 1000,
    };
    return {
      initialInputBody,
      initialInputTail,
      mouseDownLock: false,
      addTestcaseVisible: false,
      testcaseKey: 0,
      testcaseForm: {
        input: '',
        output: '',
        score_ratio: 1,
      },
      currentTestcaseIndex: -1,
      rectR: 3,
      rectRHighlight: 5,
      refreshCount: 0,
      bogiSize: [false, false, false, false, false],
      canvas: undefined,
      selectEls: [null, null],
      inputBody: Object.assign({}, initialInputBody),
      inputTail: Object.assign({}, initialInputTail),
      difficultyList: [5, 4.5, 4, 3.5, 3, 2.5, 2, 1.5, 1, 0.5, 0],
      languageList: [{
        value: 'python3',
        label: 'Python3',
      }/*, {
        value: 'c',
        label: 'C',
      }, {
        value: 'cpp',
        label: 'C++',
      }, {
        value: 'cshop',
        label: 'C#',
      }, {
        value: 'java',
        label: 'Java',
      }, {
        value: 'shell_script',
        label: 'Shell Script',
      }, {
        value: 'free_basic',
        label: 'Free Basic',
      }, {
        value: 'go',
        label: 'Go',
      }, {
        value: 'php',
        label: 'PHP',
      }*/],
      questionMediaOptions: [{
        value: 'none',
        label: this.$t('UPLOAD.UNSELECTED'),
      }, {
        value: 'youtube',
        label: this.$t('UPLOAD.YT_ADDR'),
      }, {
        value: 'voice',
        label: this.$t('UPLOAD.VOICE_RECORDING'),
      }],
      mediaOptions: [{
        value: 'none',
        label: this.$t('UPLOAD.UNSELECTED'),
      }, {
        value: 'youtube',
        label: this.$t('UPLOAD.YT_ADDR'),
      }, {
        value: 'image',
        label: this.$t('UPLOAD.IMG_FILE'),
      }, {
        value: 'voice',
        label: this.$t('UPLOAD.VOICE_RECORDING'),
      }],
    };
  },
  computed: {
    ...mapState('keyword', [
      'keywordList',
    ]),
    modifiedKeywordList() {
      const vm = this;
      return vm.keywordList.map(x => ({ value: x.keyword }));
    },
    youtubeId() {
      const vm = this;
      return getIdFromURL(vm.inputTail.questionVideo[0]);
    },
  },
  methods: {
    async generateOutput() {
      const vm = this;

      if (vm.inputTail.multipleSelection.length === 0) {
        vm.$notify({
          title: vm.$t('QUESTION.GENERATE_OUTPUT'),
          message: vm.$t('QUESTION.SELECTION_NEEDED'),
          type: 'warning',
          duration: 5000,
        });
        return;
      }

      if (vm.inputTail.language === '') {
        vm.$notify({
          title: vm.$t('QUESTION.GENERATE_OUTPUT'),
          message: vm.$t('QUESTION.LANGUAGE_NEEDED'),
          type: 'warning',
          duration: 5000,
        });
        return;
      }

      if (vm.inputTail.code === '') {
        vm.$notify({
          title: vm.$t('QUESTION.GENERATE_OUTPUT'),
          message: vm.$t('QUESTION.CODE_NEEDED'),
          type: 'warning',
          duration: 5000,
        });
        return;
      }

      const results = await Promise.all(vm.inputTail.multipleSelection.map(idx => 
        questionService.postTestcaseRun(vm.inputTail.language, vm.inputTail.code, vm.inputTail.testCaseList[idx].input)));

      const outputs = results.map(res => res.data.success ? res.data.output : '');
      const errorIndex = results.map((res, idx) => res.data.success ? -1 : vm.inputTail.multipleSelection[idx] + 1).filter(index => index > -1);
      
      outputs.forEach((output, index) => {
        vm.inputTail.testCaseList[vm.inputTail.multipleSelection[index]].output = output;
      });

      if (errorIndex.length > 0) {
        vm.$notify({
          title: vm.$t('QUESTION.GENERATE_OUTPUT'),
          message: vm.$t('QUESTION.GENERATE_ERROR', { indexs: errorIndex.join(", ") }),
          type: 'error',
          duration: 7000,
        });   
      }

      vm.testcaseKey += 1;
    },
    showChangeTestcaseDialog(index) {
      const vm = this;

      vm.testcaseForm = {
        ...vm.inputTail.testCaseList[index]
      };

      vm.currentTestcaseIndex = index;
      vm.addTestcaseVisible = true;
    },
    deleteTestcase(index) {
      const vm = this;
      
      vm.inputTail.testCaseList = vm.inputTail.testCaseList.filter((testcase, idx) => idx !== index);
      vm.$notify({
        title: vm.$t('QUESTION.DELETE_TESTCASE'),
        message: vm.$t('QUESTION.SUCCESS'),
        type: 'success',
        duration: 3000,
      });
      vm.testcaseKey += 1;
    },
    handleSelectionChange(val) {
      const vm = this;
      vm.inputTail.multipleSelection = val.map(va => vm.inputTail.testCaseList.indexOf(va));
      vm.inputTail.multipleSelection.sort();
    },
    showAddTestcaseDialog() {
      const vm = this;

      vm.testcaseForm = {
        input: '',
        output: '',
        score_ratio: 0,
      };
      vm.currentTestcaseIndex = -1;
      vm.addTestcaseVisible = true;
    },
    changeTestCase() {
      const vm = this;
      const index = vm.currentTestcaseIndex;
 
      vm.inputTail.testCaseList[index] = {
        ...vm.testcaseForm
      };

      vm.$notify({
        title: vm.$t('QUESTION.CHANGE_TESTCASE'),
        message: vm.$t('QUESTION.SUCCESS'),
        type: 'success',
        duration: 3000,
      });

      vm.addTestcaseVisible = false;
      vm.testcaseKey += 1;
    },
    addTestCase() {
      const vm = this;
      const index = vm.inputTail.testCaseList.length;

      vm.inputTail.testCaseList[index] = {
        ...vm.testcaseForm
      };

      vm.$notify({
        title: vm.$t('QUESTION.ADD_TESTCASE'),
        message: vm.$t('QUESTION.SUCCESS'),
        type: 'success',
        duration: 3000,
      });

      vm.addTestcaseVisible = false;
      vm.testcaseKey += 1;
    },
    cancelAddTestCase() {
      const vm = this;
      
      vm.$notify({
        title: vm.currentTestcaseIndex > -1 ? vm.$t('QUESTION.CHANGE_TESTCASE') : vm.$t('QUESTION.ADD_TESTCASE'),
        message: vm.$t('QUESTION.CANCELED'),
        type: 'info',
        duration: 3000,
      });
      vm.addTestcaseVisible = false;
    },
    handleChangeConnection() {
      const vm = this;
      if (vm.inputBody.questionType === 'CONNECTION') {
        vm.canvas = document.getElementById('canvas');
        vm.$nextTick(() => {
          if (vm.canvas !== undefined) {
            vm.changeBogiSize(null, null);
          }
        });
      }
    },
    changeBogiSize(file, fileList) {
      const vm = this;

      vm.bogiSize[0] = vm.$refs.MultiChoiceUpload0 === undefined || vm.$refs.MultiChoiceUpload0[0] === undefined ? false : vm.$refs.MultiChoiceUpload0[0].uploadFiles.length > 0 ? true : false;
      vm.bogiSize[1] = vm.$refs.MultiChoiceUpload1 === undefined || vm.$refs.MultiChoiceUpload1[0] === undefined ? false : vm.$refs.MultiChoiceUpload1[0].uploadFiles.length > 0 ? true : false;
      vm.bogiSize[2] = vm.$refs.MultiChoiceUpload2 === undefined || vm.$refs.MultiChoiceUpload2[0] === undefined ? false : vm.$refs.MultiChoiceUpload2[0].uploadFiles.length > 0 ? true : false;
      vm.bogiSize[3] = vm.$refs.MultiChoiceUpload3 === undefined || vm.$refs.MultiChoiceUpload3[0] === undefined ? false : vm.$refs.MultiChoiceUpload3[0].uploadFiles.length > 0 ? true : false;
      vm.bogiSize[4] = vm.$refs.MultiChoiceUpload4 === undefined || vm.$refs.MultiChoiceUpload4[0] === undefined ? false : vm.$refs.MultiChoiceUpload4[0].uploadFiles.length > 0 ? true : false;
      vm.drawCanvas();
    },
    getCursorPosition(event) {
      const vm = this;
      const rect = vm.canvas.getBoundingClientRect();
      const x = event.clientX - rect.left;
      const y = event.clientY - rect.top;
      return { x, y };
    },
    getClickElement({ x, y }) {
      const vm = this;
      // 캔버스에서 음수, 초과값 등이 떠서 처리
      const X = x <= 0 ? 1 : ( x > vm.canvas.width ? vm.canvas.width : x );
      const Y = y <= 0 ? 1 : ( y > vm.canvas.height ? vm.canvas.height : y );
      const index = [1,2,3,4,5];
      const bogiSizeTrue = vm.bogiSize.filter(size => size === true).length;
      const bogiSizeFalseHeight = bogiSizeTrue === 5 ? 0 : (vm.canvas.height - bogiSizeTrue * 100) / (5 - bogiSizeTrue);
      let YNum;
      index.forEach((i) => {
        const ithPosY = vm.dotElsPosition(i).y;
        const ithR = vm.bogiSize[i-1] === true ? 50 : bogiSizeFalseHeight / 2 ;
        if (y >= ithPosY - ithR && y < ithPosY + ithR) {
          YNum = i;
        }
      });
      const XNum = X <= vm.canvas.width * 2 / 5 ? 0 : ( X >= vm.canvas.width * 3 / 5 ? 1 : -1);
      return XNum * 5 + YNum;
    },
    updateSelectEl(elNum) {
      const vm = this;
      if (elNum < 6) {
        vm.selectEls[0] = elNum;
      } else {
        vm.selectEls[1] = elNum;
      }
    },
    refreshMatching() {
      const vm = this;
      if (vm.selectEls.length > 1 && vm.selectEls[0] !== null && vm.selectEls[1] !== null) {
        vm.inputTail.answer[vm.selectEls[0] - 1] = vm.selectEls[1];
        vm.selectEls = [null, null];
      }
    },
    resetSelectEl() {
      const vm = this;
      let ctx = vm.canvas.getContext('2d');
      vm.inputTail.answer = [null, null, null, null, null];
      vm.selectEls = [null, null];
      vm.drawLines(ctx);
    },
    drawLines(ctx) {
      const vm = this;
      // canvas 초기화
      ctx.clearRect(0, 0, vm.canvas.width, vm.canvas.height);
      vm.drawDotEls(ctx);
      for (let i = 0; i < 5; i++) { // eslint-disable-line
        if (vm.inputTail.answer[i] !== undefined && Number.isInteger(vm.inputTail.answer[i])) {
          const start = vm.dotElsPosition(i + 1);
          const end = vm.dotElsPosition(vm.inputTail.answer[i]);
          ctx.beginPath();
          ctx.moveTo(start.x, start.y);
          ctx.lineTo(end.x, end.y);
          ctx.stroke();
        }
      }
    },
    dotElsPosition(num) {
      const vm = this;
      const heightNum = num > 5 ? num - 5 : num;
      let x = num < 6 ? vm.canvas.width / 5 : vm.canvas.width * 4 / 5;
      const bogiSizeTrue = vm.bogiSize.filter(size => size === true).length;
      const bogiSizeFalseHeight = bogiSizeTrue === 5 ? 0 : (vm.canvas.height - bogiSizeTrue * 100) / (5 - bogiSizeTrue);
      let bogiSizeTrueUnderHeightNum = 0;
      let forEachCount = 1;
      vm.bogiSize.forEach((size) => {
        if (forEachCount < heightNum && size === true) {
          bogiSizeTrueUnderHeightNum += 1;
        }
        forEachCount += 1;
      });
      let y = vm.inputTail.multiChoiceMediaType === 'image' ? bogiSizeFalseHeight * (heightNum - 1 - bogiSizeTrueUnderHeightNum) + 100 * bogiSizeTrueUnderHeightNum + (vm.bogiSize[heightNum - 1] === true ? 50 : bogiSizeFalseHeight / 2) : (2 * heightNum - 1) * vm.canvas.height / 10; 
      return { x, y };
    },
    drawDotEls(ctx) {
      const vm = this;
      ctx.moveTo(vm.dotElsPosition(1).x, vm.dotElsPosition(1).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(1).x, vm.dotElsPosition(1).y, vm.selectEls[0] === 1 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[0] === 1 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(2).x, vm.dotElsPosition(2).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(2).x, vm.dotElsPosition(2).y, vm.selectEls[0] === 2 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[0] === 2 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(3).x, vm.dotElsPosition(3).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(3).x, vm.dotElsPosition(3).y, vm.selectEls[0] === 3 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[0] === 3 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(4).x, vm.dotElsPosition(4).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(4).x, vm.dotElsPosition(4).y, vm.selectEls[0] === 4 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[0] === 4 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(5).x, vm.dotElsPosition(5).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(5).x, vm.dotElsPosition(5).y, vm.selectEls[0] === 5 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[0] === 5 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(6).x, vm.dotElsPosition(6).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(6).x, vm.dotElsPosition(6).y, vm.selectEls[1] === 6 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[1] === 6 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(7).x, vm.dotElsPosition(7).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(7).x, vm.dotElsPosition(7).y, vm.selectEls[1] === 7 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[1] === 7 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(8).x, vm.dotElsPosition(8).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(8).x, vm.dotElsPosition(8).y, vm.selectEls[1] === 8 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[1] === 8 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(9).x, vm.dotElsPosition(9).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(9).x, vm.dotElsPosition(9).y, vm.selectEls[1] === 9 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[1] === 9 ? "red" : "black";
      ctx.fill();
      ctx.moveTo(vm.dotElsPosition(10).x, vm.dotElsPosition(10).y);
      ctx.beginPath();
      ctx.arc(vm.dotElsPosition(10).x, vm.dotElsPosition(10).y, vm.selectEls[1] === 10 ? vm.rectRHighlight : vm.rectR, 0, 2 * Math.PI);
      ctx.fillStyle = vm.selectEls[1] === 10 ? "red" : "black";
      ctx.fill();
    },
    drawCanvas() {
      const vm = this;
      vm.canvas = document.getElementById('canvas');
      if (vm.canvas === undefined || vm.canvas === null) {
        vm.handleChangeConnection();
      } else if (vm.canvas.getContext) {
        // 캔버스 크기 정하기;
        let ctx;
        vm.$nextTick(() => {
          const canvasCol = document.getElementById('canvasCol');
          vm.canvas.width = canvasCol.offsetWidth;
          vm.canvas.height = vm.inputTail.multiChoiceMediaType === 'voice' ? 500 : 200+vm.bogiSize.filter(size => size).length * 60;
          canvasCol.style.maxHeight = `${vm.canvas.height}px`;
          ctx = vm.canvas.getContext('2d');
          vm.drawLines(ctx);
          vm.refreshCount += 1;
          vm.canvas.addEventListener('mousedown', function(e) {
            if (vm.mouseDownLock === false) {
              vm.mouseDownLock = true;
              setTimeout(() => {
                vm.mouseDownLock = false;
              }, 100);
              const elNum = vm.getClickElement(vm.getCursorPosition(e));
              if (elNum > 0) {
                vm.updateSelectEl(elNum);
                vm.refreshMatching();
                vm.drawLines(ctx);
              }
            }
          });
        });
      }
    },
    onChangeBody() {
      const vm = this;

      vm.inputTail = Object.assign({}, vm.initialInputTail);
      vm.$set(vm.inputTail, 'questionFile', vm.$refs.questionUpload.uploadFiles);
      if (vm.inputBody.questionType === 'SHORT_ANSWER') {
        vm.$set(vm.inputTail, 'answer', ['']);
      }
      if (vm.inputBody.questionType === 'MULTIPLE_CHOICE') {
        vm.$set(vm.inputTail, 'questionList', []);
        vm.$set(vm.inputTail, 'questionVideo', []);
        vm.$set(vm.inputTail, 'answer', []);
      }
      if (vm.inputBody.questionType === 'DESCRIPTION') {
        vm.$set(vm.inputTail, 'answerFile', vm.$refs.answerUpload.uploadFiles);
      }
      if (vm.inputBody.questionType === 'SQL') {
        vm.$set(vm.inputTail, 'sqlFile', vm.$refs.sqlUpload.uploadFiles);
      }
      if (vm.inputBody.questionType === 'CONNECTION') {
        vm.$set(vm.inputTail, 'answer', ['']);
        vm.$set(vm.inputTail, 'questionList', []);
        vm.$set(vm.inputTail, 'questionVideo', []);
        vm.$set(vm.inputTail, 'choice2', []);
        vm.handleChangeConnection();
      }

    },
    onChangeMultichoiceMediaType() {
      const vm = this;
      vm.$set(vm.inputTail, 'questionList', []);
      vm.$set(vm.inputTail, 'multiChoiceMedia', []);
      vm.$set(vm.inputTail, 'audioBlob', []);
      vm.$set(vm.inputTail, 'blobURL', []);
      if (vm.inputBody.questionType === 'CONNECTION') {
        vm.handleChangeConnection();
      }
    },
    getYoutubeId(data) {
      return getIdFromURL(data === null ? '' : data);
    },
    querySearch(queryString, cb) {
      const vm = this;
      const results = queryString ?
        vm.modifiedKeywordList.filter(vm.createFilter(queryString)) : vm.modifiedKeywordList;
      // call callback function to return suggestions
      cb(results);
    },
    createFilter(queryString) { // eslint-disable-next-line
      return (link) => {
        return (link.value.toLowerCase().indexOf(queryString.toLowerCase()) === 0);
      };
    },
    reset() {
      const vm = this;
      vm.inputBody = Object.assign({}, vm.initialInputBody);
      vm.inputTail = Object.assign({}, vm.initialInputTail);
      // TODO: reset keyword list
    },
    async startRecording(slotNumber) {
      const vm = this;
      if (vm.inputTail.recordingBtnNum !== -1) {
        await vm.finishRecording(vm.inputTail.recordingBtnNum);
      }
      try {
        const stream = await navigator.mediaDevices.getUserMedia({ audio: true }); // 녹음 권한 획득
        vm.inputTail.recorder = new RecordRTCPromisesHandler(stream, {
          type: 'audio',
        });
        vm.inputTail.recorder.startRecording();
        vm.inputTail.recordingBtnNum = slotNumber;
      } catch (error) {
        vm.$notify({
          title: vm.$t('NOTIFY.REC_FAIL'),
          message: vm.$t('NOTIFY.NO_EQUP_NOT_ALLW'),
          type: 'error',
          duration: 0,
        });
      }
    },
    async finishRecording(slotNumber) {
      const vm = this;
      await vm.inputTail.recorder.stopRecording();
      if (slotNumber === 6) { // 문제에 멀티미디어를 첨부하는 경우
        vm.inputTail.audioBlob[slotNumber] = await vm.inputTail.recorder.getBlob();
        vm.inputTail.questionBlobURL = URL.createObjectURL(vm.inputTail.audioBlob[slotNumber]);
        vm.inputTail.questionVoiceFile = new File([vm.inputTail.audioBlob[slotNumber]], 'voice.webm', { type: 'audio/webm' });
      } else { // 객관식에서 멀티미디어를 첨부하는 경우
        vm.inputTail.audioBlob[slotNumber] = await vm.inputTail.recorder.getBlob();
        vm.inputTail.blobURL[slotNumber] = URL.createObjectURL(vm.inputTail.audioBlob[slotNumber]);
        vm.inputTail.multiChoiceMedia[slotNumber] = new File([vm.inputTail.audioBlob[slotNumber]], 'voice.webm', { type: 'audio/webm' });
      }
      vm.inputTail.recordingBtnNum = -1; // 현재 녹음중인 버튼이 없음을 알림
    },
    onClick(type, arg) {
      const vm = this;
      let i1;
      switch (type) {
        case 'ADD_KEYWORD': {
          let isEnroll = false;
          for (i1 = 0; i1 < vm.keywordList.length; i1 += 1) {
            if (vm.keywordList[i1].keyword === vm.inputTail.keywordName) {
              isEnroll = true;
            }
          }
          if (isEnroll === false) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.NOT_REG_KEY'),
              type: 'warning',
            });
            break;
          }
          if (vm.inputTail.assignedKeywordList.map(x => x.keyword).indexOf(vm.inputTail.keywordName) !== -1) { // eslint-disable-line
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.ALRDY_REG_KEY'),
              type: 'warning',
            });
            break;
          }
          vm.inputTail.assignedKeywordList.push({
            keyword: vm.inputTail.keywordName,
            score: vm.inputTail.keywordPoint,
          });
          vm.inputTail.keywordName = null;
          vm.inputTail.keywordPoint = null;
          break;
        }
        case 'DELETE_KEYWORD': {
          vm.inputTail.assignedKeywordList.splice(arg, 1);
          break;
        }
        case 'ADD_TEST_CASE': {
          vm.inputTail.testCaseList.push({
            input: '',
            output: '',
            score_ratio: 1,
          });
          break;
        }
        case 'DELETE_TEST_CASE': {
          if (vm.inputTail.testCaseList.length === 1) {
            vm.$notify({
              title: vm.$t('NOTIFY.TITLE'),
              message: vm.$t('NOTIFY.CANNOT_DLT_LAST'),
              type: 'warning',
            });
            break;
          }
          vm.inputTail.testCaseList.splice(arg, 1);
          break;
        }
        case 'ADD_ANSWER': {
          vm.inputTail.answer.push('');
          break;
        }
        case 'DELETE_ANSWER': {
          vm.inputTail.answer.pop();
          break;
        }
        default : {
          break;
        }
      }
    },
    handleExceed() {
      this.$message.warning(
        '파일은 1개만 업로드 할 수 있습니다.',
      );
    },
    handleChange(file, filelist) {
      if (!(['image/gif', 'image/png', 'image/jpeg', 'video/mp4'].includes(file.raw.type))) {
        this.$message.warning(this.$t('NOTIFY.WRONG_FILE_FORMAT'));
        this.inputTail.questionFile = filelist.slice(0, -1);
      }
    },
    getRefName(index) {
      return `MultiChoiceUpload${index}`;
    },
  },
};
</script>
